diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
new file mode 100644
index 000000000..c6d8c92c1
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
@@ -0,0 +1,389 @@
+package net.minecraft.client.gui.keyboard.keys;
+
+import com.b100.utils.StringUtils;
+import com.google.gson.JsonArray;
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+import net.minecraft.client.input.InputType;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.opengl.GL11;
+
+import java.lang.reflect.Type;
+import java.nio.charset.StandardCharsets;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.Locale;
+
+public class CharKey extends Key{
+    private static int EXTRAS_HOLD_LENGTH = 300;
+    protected boolean renderChar = true;
+    protected int lastRadial = 0;
+    protected final CharGroup @NotNull [] groups;
+
+    protected CharKey(int x, int y, int width, int height, boolean renderChar, CharGroup @NotNull [] groups) {
+        super(x, y, width, height);
+        this.renderChar = renderChar;
+        this.groups = groups;
+    }
+
+    @Override
+    public void render(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        super.render(mc, keyboard, originX, originY, mouseX, mouseY);
+        if (!renderChar) return;
+        boolean hovered = isHovered(originX, originY, mouseX, mouseY);
+        int texColor = hovered ? 0xFFFFA0 : 0xE0E0E0;
+
+        CharGroup currentGroup = getGroup(keyboard.getGroup());
+        {
+            CharGroup nextGroup = getGroup(keyboard.getShiftedGroup(1));
+            CharGroup lastGroup = getGroup(keyboard.getShiftedGroup(-1));
+
+            if (lastGroup != currentGroup && lastGroup != nextGroup) {
+                GL11.glPushMatrix();
+                GL11.glColor4f(0.75f, 0.75f, 0.75f, 1f);
+                GL11.glTranslatef(x + originX + 4, y + originY + 2, 0);
+                GL11.glScalef(0.75f, 0.75f, 1);
+                drawStringCentered(mc.font, String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? lastGroup.collections[0].upper : lastGroup.collections[0].lower), 0, 0, 0xE0E0E0);
+                GL11.glPopMatrix();
+            }
+
+            if (nextGroup != currentGroup) {
+                GL11.glPushMatrix();
+                GL11.glColor4f(0.75f, 0.75f, 0.75f, 1f);
+                GL11.glTranslatef(x + width + originX - 4, y + originY + 2, 0);
+                GL11.glScalef(0.75f, 0.75f, 1);
+                drawStringCentered(mc.font, String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? nextGroup.collections[0].upper : nextGroup.collections[0].lower), 0, 0, 0xE0E0E0);
+                GL11.glPopMatrix();
+            }
+        }
+//        if (isHovered) {
+//            drawStringCentered(mc.font, String.valueOf(getHoldTime()), x + width/2 + originX, y + mc.font.fontHeight/2 + 4 + originY - 10, texColor);
+//        }
+        if (getHoldTime() > EXTRAS_HOLD_LENGTH) {
+            double animProgress = MathHelper.clamp((getHoldTime() - EXTRAS_HOLD_LENGTH)/100d, 0, 1);
+            GL11.glPushMatrix();
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glEnable(GL11.GL_DEPTH_TEST);
+            GL11.glTranslatef(0, 0, 10);
+
+            final int size = (int) (64 * animProgress);
+            drawTexturedIcon(
+                x + (width - size)/2 + originX,
+                y + (height - size)/2  + originY + 2,
+                size,
+                size,
+                TextureRegistry.getTexture("minecraft:gui/screen/keyboard/radial_background"));
+
+            drawStringCentered(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.fontHeight/2 + 4 + originY, texColor);
+
+            final double dx;
+            final double dy;
+            if (mc.inputType == InputType.CONTROLLER && mc.controllerInput != null) {
+                dx = mc.controllerInput.joyLeft.getX() * 20;
+                dy = mc.controllerInput.joyLeft.getY() * 20;
+            } else {
+                dx = mouseX - (x + width/2d + originX);
+                dy = mouseY - (y + height/2d + originY);
+            }
+
+            int rIndex = getRadialIndex(mc, keyboard, dx, dy);
+
+            double r = (Math.PI * 2) / currentGroup.collections.length;
+            for (int i = 0; i < currentGroup.collections.length; i++) {
+                CharCollection collection = currentGroup.collections[i];
+
+                int charX = MathHelper.floor(x + originX + width/2d + Math.cos(r * i - Math.PI/2) * 20 * animProgress);
+                int charY = MathHelper.floor(y + originY + height/2d + Math.sin(r * i - Math.PI/2) * 20 * animProgress) - 3;
+
+                drawStringCentered(
+                    mc.font,
+                    String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? collection.upper : collection.lower),
+                    charX,
+                    charY,
+                    i == rIndex ? 0xFFFFA0 : 0xE0E0E0);
+            }
+            GL11.glDisable(GL11.GL_BLEND);
+            GL11.glPopMatrix();
+        } else {
+            drawStringCentered(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.fontHeight/2 + 4 + originY, texColor);
+        }
+        GL11.glColor4f(1f, 1f, 1f, 1f);
+    }
+
+    protected int getRadialIndex(Minecraft mc, ScreenKeyboard keyboard, double dx, double dy) {
+        if (getHoldTime() < EXTRAS_HOLD_LENGTH) {
+            lastRadial = 0;
+            return 0;
+        }
+
+        final int deadzone = 7;
+        if (Math.hypot(dx, dy) < deadzone) {
+            return lastRadial;
+        }
+
+        CharGroup currentGroup = getGroup(keyboard.getGroup());
+        double r = (Math.PI * 2) / currentGroup.collections.length;
+
+        double mouseR = Math.atan2(dy, dx) + Math.PI/2 + r/2;
+        if (mouseR < 0) mouseR += Math.PI * 2;
+
+        int radial = MathHelper.floor(mouseR / r) % currentGroup.collections.length;
+        lastRadial = radial;
+        return radial;
+    }
+
+    @Override
+    public void pressAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        super.pressAction(mc, keyboard, originX, originY, mouseX, mouseY);
+    }
+
+    @Override
+    public void releaseAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        super.releaseAction(mc, keyboard, originX, originY, mouseX, mouseY);
+        keyboard.typeChar(Keyboard.KEY_NONE, getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY));
+    }
+
+    protected char getActiveChar(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        CharGroup group = getGroup(keyboard.getGroup());
+
+        final double dx;
+        final double dy;
+        if (mc.inputType == InputType.CONTROLLER && mc.controllerInput != null) {
+            dx = mc.controllerInput.joyLeft.getX() * 20;
+            dy = mc.controllerInput.joyLeft.getY() * 20;
+        } else {
+            dx = mouseX - (x + width/2d + originX);
+            dy = mouseY - (y + height/2d + originY);
+        }
+
+        int rI = getRadialIndex(mc, keyboard, dx, dy);
+        return keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? group.collections[rI].upper : group.collections[rI].lower;
+    }
+
+    protected CharGroup getGroup(int group) {
+        return group < groups.length ? groups[group] : groups[0];
+    }
+
+    @Override
+    public boolean isDown(Minecraft mc, ScreenKeyboard keyboard) {
+        return super.isDown(mc, keyboard);
+    }
+
+    @Override
+    public int highestGroup() {
+        return groups.length - 1;
+    }
+
+    protected static class CharGroup {
+        protected final CharCollection @NotNull [] collections;
+
+        public CharGroup(CharCollection @NotNull [] collections) {
+            this.collections = collections;
+        }
+    }
+
+    protected static class CharCollection {
+        public char lower;
+        public char upper;
+        public CharCollection(char lower, char upper) {
+            this.lower = lower;
+            this.upper = upper;
+        }
+    }
+
+    public static class Serializer implements JsonSerializer<CharKey>, JsonDeserializer<CharKey> {
+        public static final int DEFAULT_WIDTH = 18;
+        public static final int DEFAULT_HEIGHT = 18;
+
+        public static final boolean DEFAULT_RENDER_CHAR = true;
+
+        public static final String DEFAULT_TEXTURE_UP = "minecraft:gui/widgets/keyboard/key/up";
+        public static final String DEFAULT_TEXTURE_DOWN = "minecraft:gui/widgets/keyboard/key/down";
+        public static final String DEFAULT_TEXTURE_UP_HOVERED = "minecraft:gui/widgets/keyboard/key/up_hovered";
+        public static final String DEFAULT_TEXTURE_DOWN_HOVERED = "minecraft:gui/widgets/keyboard/key/down_hovered";
+
+        @Override
+        public CharKey deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+            JsonObject obj = json.getAsJsonObject();
+            CharKeyBuilder charKeyBuilder = new CharKeyBuilder(obj.get("x").getAsInt(), obj.get("y").getAsInt());
+            charKeyBuilder.setWidth(obj.has("width") ? obj.get("width").getAsInt() : DEFAULT_WIDTH);
+            charKeyBuilder.setHeight(obj.has("height") ? obj.get("height").getAsInt() : DEFAULT_HEIGHT);
+            charKeyBuilder.setButton(obj.has("button") ? Key.ButtonEnum.valueOf(obj.get("button").getAsString().toUpperCase(Locale.ROOT)) : null);
+            charKeyBuilder.setRenderChar(obj.has("renderChar") ? obj.get("renderChar").getAsBoolean() : DEFAULT_RENDER_CHAR);
+
+            String texUp = DEFAULT_TEXTURE_UP;
+            String texDown = DEFAULT_TEXTURE_DOWN;
+            String texUpHovered = DEFAULT_TEXTURE_UP_HOVERED;
+            String texDownHovered = DEFAULT_TEXTURE_DOWN_HOVERED;
+
+            if (obj.has("textures")) {
+                JsonObject textures = obj.getAsJsonObject("textures");
+                if (textures.has("up")) texUp = textures.get("up").getAsString();
+                if (textures.has("down")) texDown = textures.get("down").getAsString();
+                if (textures.has("up_hovered")) texUpHovered = textures.get("up_hovered").getAsString();
+                if (textures.has("down_hovered")) texDownHovered = textures.get("down_hovered").getAsString();
+            }
+            charKeyBuilder.setTextures(
+                texUp,
+                texDown,
+                texUpHovered,
+                texDownHovered);
+
+            JsonArray groups = obj.getAsJsonArray("groups");
+            for (JsonElement e : groups) {
+                JsonArray collections = e.getAsJsonArray();
+                CharCollection[] charCollections = new CharCollection[collections.size()];
+                int i = 0;
+                for (JsonElement r : collections) {
+                    JsonObject collection = r.getAsJsonObject();
+                    char lower = (char) collection.get("lower").getAsInt();
+                    char upper = collection.has("upper") ? (char) collection.get("upper").getAsInt() : Character.toUpperCase(lower);
+                    charCollections[i++] = new CharCollection(lower, upper);
+                }
+                charKeyBuilder.addGroup(new CharGroup(charCollections));
+            }
+
+            return charKeyBuilder.build();
+        }
+
+        @Override
+        public JsonElement serialize(CharKey src, Type typeOfSrc, JsonSerializationContext context) {
+            JsonObject object = new JsonObject();
+            object.addProperty("type", Key.Serializer.KEY_CLASS_TO_ID.get(src.getClass()));
+
+            object.addProperty("x", src.x);
+            object.addProperty("y", src.y);
+            if (src.width != DEFAULT_WIDTH) object.addProperty("width", src.width);
+            if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
+            if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
+            if (src.renderChar != DEFAULT_RENDER_CHAR) object.addProperty("renderChar", src.renderChar);
+
+            boolean ku = !src.keyUp.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP);
+            boolean kd = !src.keyDown.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
+            boolean kuh = !src.keyUpHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
+            boolean kdh = !src.keyDownHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
+            if (ku || kd || kuh || kdh) {
+                JsonObject textureObject = new JsonObject();
+                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                object.add("textures", textureObject);
+            }
+
+            JsonArray groups = new JsonArray(src.groups.length);
+            for (CharGroup group : src.groups) {
+                JsonArray collections = new JsonArray(group.collections.length);
+                for (CharCollection collection : group.collections) {
+                    JsonObject o = new JsonObject();
+                    o.addProperty("lower", (int)collection.lower);
+                    o.addProperty("upper", (int)collection.upper);
+                    collections.add(o);
+                }
+                groups.add(collections);
+            }
+            object.add("groups", groups);
+            return object;
+        }
+    }
+
+    public static class CharKeyBuilder {
+        private final int x;
+        private final int y;
+        private int width = Serializer.DEFAULT_WIDTH;
+        private int height = Serializer.DEFAULT_HEIGHT;
+
+        private ButtonEnum controllerButton = null;
+        private boolean renderChar = Serializer.DEFAULT_RENDER_CHAR;
+
+        private String texUp = Serializer.DEFAULT_TEXTURE_UP;
+        private String texDown = Serializer.DEFAULT_TEXTURE_DOWN;
+        private String texUpHovered = Serializer.DEFAULT_TEXTURE_UP_HOVERED;
+        private String texDownHovered = Serializer.DEFAULT_TEXTURE_DOWN_HOVERED;
+
+        private final List<CharGroup> groups = new ArrayList<>();
+
+        public CharKeyBuilder(int x, int y) {
+            this.x = x;
+            this.y = y;
+        }
+
+        public CharKeyBuilder setWidth(int width) {
+            this.width = width;
+            return this;
+        }
+
+        public CharKeyBuilder setHeight(int height) {
+            this.height = height;
+            return this;
+        }
+
+        public CharKeyBuilder setButton(@Nullable ButtonEnum button) {
+            this.controllerButton = button;
+            return this;
+        }
+
+        public CharKeyBuilder setRenderChar(boolean renderChar) {
+            this.renderChar = renderChar;
+            return this;
+        }
+
+        public CharKeyBuilder setTextures(String keyUp, String keyDown, String keyUpHovered, String keyDownHovered) {
+            this.texUp = keyUp;
+            this.texDown = keyDown;
+            this.texUpHovered = keyUpHovered;
+            this.texDownHovered = keyDownHovered;
+            return this;
+        }
+
+        public CharKeyBuilder addGroup(char c) {
+            CharCollection collection = new CharCollection(c, Character.toUpperCase(c));
+            groups.add(new CharGroup(new CharCollection[]{collection}));
+            return this;
+        }
+
+        public CharKeyBuilder addGroup(char lower, char upper) {
+            CharCollection collection = new CharCollection(lower, upper);
+            groups.add(new CharGroup(new CharCollection[]{collection}));
+            return this;
+        }
+
+        public CharKeyBuilder addGroup(char[] ... group) {
+            CharCollection[] collections = new CharCollection[group.length];
+            for (int i = 0; i < group.length; i++) {
+                char[] arr = group[i];
+                if (arr.length > 1) {
+                    collections[i] = new CharCollection(arr[0], arr[1]);
+                } else {
+                    collections[i] = new CharCollection(arr[0], Character.toUpperCase(arr[0]));
+                }
+            }
+            groups.add(new CharGroup(collections));
+            return this;
+        }
+
+        protected CharKeyBuilder addGroup(CharGroup group) {
+            groups.add(group);
+            return this;
+        }
+
+        public CharKey build() {
+            CharGroup[] compiledGroups = groups.toArray(new CharGroup[0]);
+            CharKey key = new CharKey(x, y, width, height, renderChar, compiledGroups);
+            key.setControllerButton(controllerButton).setTextures(texUp, texDown, texUpHovered, texDownHovered);
+            return key;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CursorKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CursorKey.java
new file mode 100644
index 000000000..7a52a755a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CursorKey.java
@@ -0,0 +1,100 @@
+package net.minecraft.client.gui.keyboard.keys;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+
+import java.lang.reflect.Type;
+import java.util.Locale;
+
+public class CursorKey extends Key{
+    protected final int cursorOffset;
+    public CursorKey(int x, int y, int width, int height, int cursorOffset) {
+        super(x, y, width, height);
+        this.cursorOffset = cursorOffset;
+    }
+
+    @Override
+    public void pressAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        super.pressAction(mc, keyboard, originX, originY, mouseX, mouseY);
+        keyboard.editor.moveCursor(cursorOffset);
+    }
+
+    public static class Serializer implements JsonSerializer<CursorKey>, JsonDeserializer<CursorKey> {
+        public static final int DEFAULT_WIDTH = 25;
+        public static final int DEFAULT_HEIGHT = 18;
+
+        public static final String DEFAULT_TEXTURE_NEXT_UP = "minecraft:gui/widgets/keyboard/key_page_next/up";
+        public static final String DEFAULT_TEXTURE_NEXT_DOWN = "minecraft:gui/widgets/keyboard/key_page_next/down";
+        public static final String DEFAULT_TEXTURE_NEXT_UP_HOVERED = "minecraft:gui/widgets/keyboard/key_page_next/up_hovered";
+        public static final String DEFAULT_TEXTURE_NEXT_DOWN_HOVERED = "minecraft:gui/widgets/keyboard/key_page_next/down_hovered";
+
+        public static final String DEFAULT_TEXTURE_LAST_UP = "minecraft:gui/widgets/keyboard/key_page_last/up";
+        public static final String DEFAULT_TEXTURE_LAST_DOWN = "minecraft:gui/widgets/keyboard/key_page_last/down";
+        public static final String DEFAULT_TEXTURE_LAST_UP_HOVERED = "minecraft:gui/widgets/keyboard/key_page_last/up_hovered";
+        public static final String DEFAULT_TEXTURE_LAST_DOWN_HOVERED = "minecraft:gui/widgets/keyboard/key_page_last/down_hovered";
+
+        @Override
+        public CursorKey deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+            JsonObject obj = json.getAsJsonObject();
+            int x = obj.get("x").getAsInt();
+            int y = obj.get("y").getAsInt();
+            int width = obj.has("width") ? obj.get("width").getAsInt() : DEFAULT_WIDTH;
+            int height = obj.has("height") ? obj.get("height").getAsInt() : DEFAULT_HEIGHT;
+            ButtonEnum button = obj.has("button") ? Key.ButtonEnum.valueOf(obj.get("button").getAsString().toUpperCase(Locale.ROOT)) : null;
+
+            int amount = obj.get("offset").getAsInt();
+
+            String texUp = amount >= 0 ? DEFAULT_TEXTURE_NEXT_UP : DEFAULT_TEXTURE_LAST_UP;
+            String texDown = amount >= 0 ? DEFAULT_TEXTURE_NEXT_DOWN : DEFAULT_TEXTURE_LAST_DOWN;
+            String texUpHovered = amount >= 0 ? DEFAULT_TEXTURE_NEXT_UP_HOVERED : DEFAULT_TEXTURE_LAST_UP_HOVERED;
+            String texDownHovered = amount >= 0 ? DEFAULT_TEXTURE_NEXT_DOWN_HOVERED : DEFAULT_TEXTURE_LAST_DOWN_HOVERED;
+
+            if (obj.has("textures")) {
+                JsonObject textures = obj.getAsJsonObject("textures");
+                if (textures.has("up")) texUp = textures.get("up").getAsString();
+                if (textures.has("down")) texDown = textures.get("down").getAsString();
+                if (textures.has("up_hovered")) texUpHovered = textures.get("up_hovered").getAsString();
+                if (textures.has("down_hovered")) texDownHovered = textures.get("down_hovered").getAsString();
+            }
+            CursorKey key = new CursorKey(x, y, width, height, amount);
+            key.setTextures(texUp, texDown, texUpHovered, texDownHovered);
+            key.setControllerButton(button);
+            return key;
+        }
+
+        @Override
+        public JsonElement serialize(CursorKey src, Type typeOfSrc, JsonSerializationContext context) {
+            JsonObject object = new JsonObject();
+            object.addProperty("type", Key.Serializer.KEY_CLASS_TO_ID.get(src.getClass()));
+
+            object.addProperty("x", src.x);
+            object.addProperty("y", src.y);
+            if (src.width != DEFAULT_WIDTH) object.addProperty("width", src.width);
+            if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
+            if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
+
+            boolean ku = true;
+            boolean kd = true;
+            boolean kuh = true;
+            boolean kdh = true;
+            if (ku || kd || kuh || kdh) {
+                JsonObject textureObject = new JsonObject();
+                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                object.add("textures", textureObject);
+            }
+
+            object.addProperty("offset", src.cursorOffset);
+            return object;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/EnterKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/EnterKey.java
new file mode 100644
index 000000000..db15ae8e6
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/EnterKey.java
@@ -0,0 +1,96 @@
+package net.minecraft.client.gui.keyboard.keys;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+
+import java.lang.reflect.Type;
+import java.util.Locale;
+
+public class EnterKey extends Key{
+
+    public EnterKey(int x, int y, int width, int height) {
+        super(x, y, width, height);
+        setTextures(
+            "minecraft:gui/widgets/keyboard/key_enter/up",
+            "minecraft:gui/widgets/keyboard/key_enter/down",
+            "minecraft:gui/widgets/keyboard/key_enter/up_hovered",
+            "minecraft:gui/widgets/keyboard/key_enter/down_hovered");
+    }
+
+    @Override
+    public void pressAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        super.pressAction(mc, keyboard, originX, originY, mouseX, mouseY);
+        keyboard.close();
+    }
+
+    public static class Serializer implements JsonSerializer<EnterKey>, JsonDeserializer<EnterKey> {
+        public static final int DEFAULT_WIDTH = 25;
+        public static final int DEFAULT_HEIGHT = 18;
+
+        public static final String DEFAULT_TEXTURE_UP = "minecraft:gui/widgets/keyboard/key_enter/up";
+        public static final String DEFAULT_TEXTURE_DOWN = "minecraft:gui/widgets/keyboard/key_enter/down";
+        public static final String DEFAULT_TEXTURE_UP_HOVERED = "minecraft:gui/widgets/keyboard/key_enter/up_hovered";
+        public static final String DEFAULT_TEXTURE_DOWN_HOVERED = "minecraft:gui/widgets/keyboard/key_enter/down_hovered";
+
+        @Override
+        public EnterKey deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+            JsonObject obj = json.getAsJsonObject();
+            int x = obj.get("x").getAsInt();
+            int y = obj.get("y").getAsInt();
+            int width = obj.has("width") ? obj.get("width").getAsInt() : DEFAULT_WIDTH;
+            int height = obj.has("height") ? obj.get("height").getAsInt() : DEFAULT_HEIGHT;
+            ButtonEnum button = obj.has("button") ? Key.ButtonEnum.valueOf(obj.get("button").getAsString().toUpperCase(Locale.ROOT)) : null;
+
+            String texUp = DEFAULT_TEXTURE_UP;
+            String texDown = DEFAULT_TEXTURE_DOWN;
+            String texUpHovered = DEFAULT_TEXTURE_UP_HOVERED;
+            String texDownHovered = DEFAULT_TEXTURE_DOWN_HOVERED;
+
+            if (obj.has("textures")) {
+                JsonObject textures = obj.getAsJsonObject("textures");
+                if (textures.has("up")) texUp = textures.get("up").getAsString();
+                if (textures.has("down")) texDown = textures.get("down").getAsString();
+                if (textures.has("up_hovered")) texUpHovered = textures.get("up_hovered").getAsString();
+                if (textures.has("down_hovered")) texDownHovered = textures.get("down_hovered").getAsString();
+            }
+            EnterKey key = new EnterKey(x, y, width, height);
+            key.setTextures(texUp, texDown, texUpHovered, texDownHovered);
+            key.setControllerButton(button);
+            return key;
+        }
+
+        @Override
+        public JsonElement serialize(EnterKey src, Type typeOfSrc, JsonSerializationContext context) {
+            JsonObject object = new JsonObject();
+            object.addProperty("type", Key.Serializer.KEY_CLASS_TO_ID.get(src.getClass()));
+
+            object.addProperty("x", src.x);
+            object.addProperty("y", src.y);
+            if (src.width != DEFAULT_WIDTH) object.addProperty("width", src.width);
+            if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
+            if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
+
+            boolean ku = !src.keyUp.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP);
+            boolean kd = !src.keyDown.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
+            boolean kuh = !src.keyUpHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
+            boolean kdh = !src.keyDownHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
+            if (ku || kd || kuh || kdh) {
+                JsonObject textureObject = new JsonObject();
+                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                object.add("textures", textureObject);
+            }
+
+            return object;
+        }
+    }
+}
